package nl.tue.id.zoo.ui;

import java.awt.*;

import javax.swing.*;
import java.awt.Dimension;
import java.awt.BorderLayout;
import nl.tue.id.zoo.animal.Animal;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import nl.tue.id.zoo.util.Pet;
import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import java.util.Random;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class CatBody extends JFrame implements AnimalBody {
    BorderLayout borderLayout1 = new BorderLayout();
    JButton mouth = new JButton();
    Animal animal = null;

    public CatBody() {
        try {
            jbInit();
            this.setVisible(true);
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }


    private void jbInit() throws Exception {
        Random r = new Random();
        this.setSize(new Dimension(425, 159));
        this.addMouseListener(new CatBody_this_mouseAdapter(this));
        getContentPane().setLayout(borderLayout1);

        this.setLocation(r.nextInt(300), r.nextInt(300));
        mouth.setEnabled(false);

        mouth.setText("Mouth");
        mouth.addActionListener(new CatBody_mouth_actionAdapter(this));
        this.getContentPane().add(mouth, java.awt.BorderLayout.SOUTH);

    }

    public void setAnimal(Animal animal) {
        this.animal = animal;
        if (animal instanceof Pet) {
            mouth.setEnabled(true);
        }
    }


    public void tag(String tag) {
        this.setTitle(tag);
    }

    public void grow(int size) {
        this.setSize(this.getSize().width + size,
                     this.getSize().height + size);
        this.validate();
    }

    public void shaking() {
        Thread t = new Thread() {
            Random r = new Random();

            public void run() {
                for (int i = 0; i < 10; i++) {
                    setLocation(getLocation().x + r.nextInt(10) - 5,
                                getLocation().x + r.nextInt(10) - 5);
                    try {
                        sleep(40);
                    } catch (InterruptedException ex) {
                    }
                }
            }
        };

        t.start();

    }

    public void this_mousePressed(MouseEvent e) {

        if (animal instanceof Pet) {
            ((Pet) animal).play();
        }
    }

    public void mouth_actionPerformed(ActionEvent e) {
        animal.eat(BuffetTable.getTheTable().whatHasBeenChoosen());

    }


}


class CatBody_this_mouseAdapter extends MouseAdapter {
    private CatBody adaptee;
    CatBody_this_mouseAdapter(CatBody adaptee) {
        this.adaptee = adaptee;
    }

    public void mousePressed(MouseEvent e) {
        adaptee.this_mousePressed(e);
    }
}


class CatBody_mouth_actionAdapter implements ActionListener {
    private CatBody adaptee;
    CatBody_mouth_actionAdapter(CatBody adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.mouth_actionPerformed(e);
    }
}
