package nl.tue.id.zoo.ui;

import java.awt.*;

import javax.swing.*;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import java.util.Random;
import nl.tue.id.zoo.util.Pet;
import nl.tue.id.zoo.animal.Animal;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class DogBody extends JFrame implements AnimalBody {
    BorderLayout borderLayout1 = new BorderLayout();
    JButton mouth = new JButton();
    Animal animal = null;

    public DogBody() {
        try {
            jbInit();
            this.setVisible(true);
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }



    private void jbInit() throws Exception {
        Random r = new Random();
        this.getContentPane().setBackground(Color.orange);
        this.setSize(new Dimension(400, 300));
        this.addMouseListener(new DogBody_this_mouseAdapter(this));

        getContentPane().setLayout(borderLayout1);

        this.setLocation(r.nextInt(300), r.nextInt(300));
        mouth.setEnabled(false);

        mouth.setText("Mouth");
        mouth.addActionListener(new DogBody_mouth_actionAdapter(this));
        this.getContentPane().add(mouth, java.awt.BorderLayout.SOUTH);

    }

    public void mouth_actionPerformed(ActionEvent e) {
        animal.eat(BuffetTable.getTheTable().whatHasBeenChoosen());

    }

    public void this_mousePressed(MouseEvent e) {
        if (animal instanceof Pet) {
            ((Pet) animal).play();
        }
    }

    public void setAnimal(Animal animal) {
        this.animal = animal;
        if (animal instanceof Pet) {
            mouth.setEnabled(true);
        }
    }




    public void tag(String tag) {
        this.setTitle(tag);
    }

    public void grow(int size) {
        this.setSize(this.getSize().width + size,
                     this.getSize().height + size);
        this.validate();
    }


}


class DogBody_this_mouseAdapter extends MouseAdapter {
    private DogBody adaptee;
    DogBody_this_mouseAdapter(DogBody adaptee) {
        this.adaptee = adaptee;
    }

    public void mousePressed(MouseEvent e) {
        adaptee.this_mousePressed(e);
    }
}


class DogBody_mouth_actionAdapter implements ActionListener {
    private DogBody adaptee;
    DogBody_mouth_actionAdapter(DogBody adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.mouth_actionPerformed(e);
    }
}
